#ifndef spi00am_h
#define spi00am_h

#include <windows.h>

/*-------------------------------------------------------------------------*/
// t@C\
/*-------------------------------------------------------------------------*/
#pragma pack(push)
#pragma pack(1) //\̂̃oE1oCgɂ
typedef struct fileInfo
{
	unsigned char method[8];	/* k@̎ */
	unsigned long position;		/* t@Cł̈ʒu */
	unsigned long compsize;		/* kꂽTCY */
	unsigned long filesize;		/* ̃t@CTCY */
	long /*time_t*/ timestamp;	/* t@C̍XV */
	char path[200];				/* ΃pX */
	char filename[200];			/* t@Cl[ */
	unsigned long crc;			/* CRC */
} fileInfo;
#pragma pack(pop)

/*-------------------------------------------------------------------------*/
// G[R[h
/*-------------------------------------------------------------------------*/
#define SPI_NO_FUNCTION			-1	/* ̋@\̓CvgĂȂ */
#define SPI_ALL_RIGHT			0	/* I */
#define SPI_ABORT				1	/* R[obN֐0Ԃ̂œWJ𒆎~ */
#define SPI_NOT_SUPPORT			2	/* m̃tH[}bg */
#define SPI_OUT_OF_ORDER		3	/* f[^Ă */
#define SPI_NO_MEMORY			4	/* [mۏoȂ */
#define SPI_MEMORY_ERROR		5	/* [G[ */
#define SPI_FILE_READ_ERROR		6	/* t@C[hG[ */
#define	SPI_WINDOW_ERROR		7	/* JȂ (J̃G[R[h) */
#define SPI_OTHER_ERROR			8	/* G[ */
#define	SPI_FILE_WRITE_ERROR	9	/* ݃G[ (J̃G[R[h) */
#define	SPI_END_OF_FILE			10	/* t@CI[ (J̃G[R[h) */

/*-------------------------------------------------------------------------*/
// '00AM'֐̃vg^Cv錾
/*-------------------------------------------------------------------------*/
typedef int (CALLBACK *SPI_PROGRESS)(int, int, long);
extern "C" {
	int __declspec(dllexport) __stdcall GetPluginInfo
			(int infono, LPSTR buf, int buflen);
	int __declspec(dllexport) __stdcall IsSupported(LPSTR filename, DWORD dw);
	int __declspec(dllexport) __stdcall GetArchiveInfo(
			LPSTR buf, long len, unsigned int flag, HLOCAL *lphInf);
	int __declspec(dllexport) __stdcall GetFileInfo(LPSTR buf,long len,
			LPSTR filename, unsigned int flag, fileInfo *lpInfo);
	int __declspec(dllexport) __stdcall GetFile(LPSTR src,long len,
			   LPSTR dest, unsigned int flag,
			   SPI_PROGRESS prgressCallback, long lData);
	int __declspec(dllexport) __stdcall GetPreview
			(LPSTR buf,long len, unsigned int flag,
			 HANDLE *pHBInfo, HANDLE *pHBm,
			 SPI_PROGRESS lpPrgressCallback, long lData);
}

#endif
